// listBoxExDlg.cpp : implementation file
//

#include "stdafx.h"
#include <afxcoll.h>
#include <afxtempl.h>
#include "srlistbox.h"
#include "listBoxEx.h"
#include "listBoxExDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog {
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD) {
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListBoxExDlg dialog

CListBoxExDlg::CListBoxExDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CListBoxExDlg::IDD, pParent) {
	//{{AFX_DATA_INIT(CListBoxExDlg)
	m_singleSelect = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CListBoxExDlg::~CListBoxExDlg() {
	_statArray.RemoveAll();
}


void CListBoxExDlg::DoDataExchange(CDataExchange* pDX) {
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CListBoxExDlg)
	DDX_Control(pDX, IDC_LIST1, m_listBox);
	DDX_Check(pDX, IDC_CHECK1, m_singleSelect);
	//}}AFX_DATA_MAP
	if(pDX->m_bSaveAndValidate)  {  //We only get data from control to storage
		m_listBox.UpdateData(pDX->m_bSaveAndValidate);
	}
}

BEGIN_MESSAGE_MAP(CListBoxExDlg, CDialog)
	//{{AFX_MSG_MAP(CListBoxExDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_LBN_SELCHANGE(IDC_LIST1, OnSelchangeList1)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListBoxExDlg message handlers

BOOL CListBoxExDlg::OnInitDialog() {
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL) {
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty()) {
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	_statArray.RemoveAll();
	_statArray.Add("MEAN");
	_statArray.Add("MEDIAN");
	_statArray.Add("ONESDPLUS");
	_statArray.Add("ONESDMINUS");
	_statArray.Add("TWOSDPLUS");
	_statArray.Add("TWOSDMINUS");

	m_listBox.InsertString( -1, "Mean" );
	m_listBox.InsertString( -1, "Median" );
	m_listBox.InsertString( -1, "Mean + Standard Deviation" );
	m_listBox.InsertString( -1, "Mean - Standard Deviation" );
	m_listBox.InsertString( -1, "Mean + 2 Times Standard Deviation" );
	m_listBox.InsertString( -1, "Mean - 2 Times Standard Deviation" );

	for(int i=0;i<6;i++)
		m_listBox.SetItemDataPtr( i, &(_statArray[i]) );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CListBoxExDlg::OnSysCommand(UINT nID, LPARAM lParam) {
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else {
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CListBoxExDlg::OnPaint() {
	if (IsIconic())	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else {
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CListBoxExDlg::OnQueryDragIcon() {
	return (HCURSOR) m_hIcon;
}

void CListBoxExDlg::OnSelchangeList1() {
	m_listBox.UpdateData(TRUE);
//This is where life can be made easier.
//once update data is called I can use the control to get the following info with ease.
//This becomes specially usefull when frequent retrieval of data is required.

//Number of selections made
	int iSelections = m_listBox.GetSelectionArray().GetSize();  //Get number of list box selections
	for(int i=0;i<iSelections;i++) {
//Item Text
		CString sSelectedStat = m_listBox.GetSelectionArray().GetAt(i)->GetText();
//Item Data
		DWORD itemData = m_listBox.GetSelectionArray().GetAt(i)->GetItemData();
	}
}

void CListBoxExDlg::OnCheck1() {
	UpdateData(TRUE);
	if(	m_singleSelect )
		m_listBox.SetSingleSelect(true);
	else
		m_listBox.SetSingleSelect(false);
}
